var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Link } from 'react-router-dom';
import invariant from 'tiny-invariant';
import { useNamedRouting } from './NamedRouter';
export const NamedLink = (_a) => {
    var { to, params, children } = _a, otherProps = __rest(_a, ["to", "params", "children"]);
    const context = useNamedRouting();
    invariant(context, 'You should not use <NamedLink> outside a <NamedRouter>');
    const { getPath } = context;
    return (React.createElement(Link, Object.assign({}, otherProps, { to: getPath(to, params) }), children));
};
NamedLink.displayName = 'NamedLink';
