import React, { createContext, useContext } from 'react';
import { BrowserRouter } from 'react-router-dom';
import { Route } from 'react-router';
import { buildRoutingContext } from './utils';
export const routerContext = createContext(buildRoutingContext([], {}));
export const useNamedRouting = () => useContext(routerContext);
export const NamedRouter = ({ routerComponent: RouterComponent = BrowserRouter, routerProps, routes, children, }) => (React.createElement(RouterComponent, Object.assign({}, routerProps),
    React.createElement(Route, null, ({ history, location }) => (React.createElement(routerContext.Provider, { value: buildRoutingContext(routes, location, history) }, children)))));
NamedRouter.displayName = 'NamedRouter';
