import React from 'react';
import { BrowserRouterProps, RouteProps } from 'react-router-dom';
import { BaseRoutingContext, RoutingContext } from './utils';
export declare type NamedRouteConfig<T = {
    [key: string]: any;
}> = T & Omit<RouteProps, 'children'> & {
    name?: string;
    path?: string;
    routes?: NamedRouteConfig<T>[];
};
export declare type NamedRouterProps<TRouterProps = BrowserRouterProps> = TRouterProps & {
    routes: NamedRouteConfig[];
    routerComponent?: React.ComponentType<TRouterProps>;
    routerProps?: TRouterProps;
    children?: React.ReactNode;
};
export declare const routerContext: React.Context<BaseRoutingContext | RoutingContext>;
export declare const useNamedRouting: () => BaseRoutingContext | RoutingContext;
export declare const NamedRouter: React.FC<NamedRouterProps>;
