import { History, Location } from 'history';
import { NamedRouteConfig } from './NamedRouter';
export interface ExtendedRouteConfig extends NamedRouteConfig {
    parents: string[];
    regex?: RegExp;
}
export declare const buildRoutePath: (map: Map<string, ExtendedRouteConfig>, name: string, params?: any) => string;
export declare const mapRoutes: (routes: NamedRouteConfig<{
    [key: string]: any;
}>[], parents?: string[], map?: Map<string, ExtendedRouteConfig>) => Map<string, ExtendedRouteConfig>;
export declare class BaseRoutingContext {
    protected readonly routesMap: Map<string, ExtendedRouteConfig>;
    location: Location | null;
    constructor(routesMap: Map<string, ExtendedRouteConfig>);
    match: (pathname: string) => ExtendedRouteConfig | null;
    getPath: <TParams>(name: string, params?: TParams | undefined) => string;
    getRawPath: (name: string) => string | (string[] & string);
    getRoute: (name: string) => ExtendedRouteConfig;
}
export declare class RoutingContext extends BaseRoutingContext {
    protected history: History;
    constructor(routesMap: Map<string, ExtendedRouteConfig>, history: History);
    push: <TParams>(name: string, params?: TParams | undefined) => void;
    replace: <TParams>(name: string, params?: TParams | undefined) => void;
}
export declare function buildRoutingContext(routes: NamedRouteConfig[], location?: Location | string | null): BaseRoutingContext;
export declare function buildRoutingContext(routes: NamedRouteConfig[], location?: Location | string | null, history?: History): RoutingContext;
